package muvitorkit.dialogs;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.EditPartViewer.Conditional;
import org.eclipse.gef.tools.SelectionTool;
import org.eclipse.swt.events.MouseEvent;

import roneditor.gef.editparts.objectnet.ONTransitionEditPart;
import roneditor.gef.figures.objectnet.NodeFigure;
import roneditor.ui.dialogs.FireDialog;

public class TransitionSelectionTool extends SelectionTool {

	public TransitionSelectionTool(final FireDialog fireDialog) {
	}

	@Override
	protected void showHoverFeedback() {
		if (getTargetEditPart() == null) {
			return;
		}
		if (getTargetHoverRequest() == null) {
			return;
		}

		// System.out.println("TransitionSelectionTool.showHoverFeedback()");
		// NodeFigure nf = (NodeFigure)
		// ((ONTransitionEditPart)getTargetEditPart()).getFigure();
		// nf.setGlow(true);
		// ((NodeFigure) getHostFigure()).setGlow(false);
		super.showHoverFeedback();
	}

	@Override
	protected void showTargetFeedback() {
		super.showTargetFeedback();

		if (getTargetEditPart() == null) {
			return;
		}
		if (getTargetEditPart() instanceof ONTransitionEditPart) {
			final NodeFigure nf = (NodeFigure) ((ONTransitionEditPart) getTargetEditPart())
					.getFigure();
			nf.setGlow(true);
		}

	}

	@Override
	protected void eraseHoverFeedback() {
		super.eraseHoverFeedback();
	}

	@Override
	protected void eraseTargetFeedback() {
		super.eraseTargetFeedback();

		if (getTargetEditPart() == null) {
			return;
		}
		if (getTargetEditPart() instanceof ONTransitionEditPart) {
			final NodeFigure nf = (NodeFigure) ((ONTransitionEditPart) getTargetEditPart())
					.getFigure();
			nf.setGlow(false);
		}
	}

	@Override
	public void mouseDrag(final MouseEvent e, final EditPartViewer viewer) {
	}

	@Override
	public void mouseDoubleClick(final MouseEvent e, final EditPartViewer viewer) {
	}

	@Override
	public void mouseHover(final MouseEvent me, final EditPartViewer viewer) {
	}

	@Override
	public void mouseUp(final MouseEvent me, final EditPartViewer viewer) {
		if (!isViewerImportant(viewer)) {
			return;
		}
		setViewer(viewer);
		getCurrentInput().setInput(me);
		getCurrentInput().setMouseButton(me.button, false);
		handleButtonUp(me.button);
	}

	@Override
	protected Conditional getTargetingConditional() {
		return new Conditional() {
			@Override
			public boolean evaluate(final EditPart editpart) {
				return editpart instanceof ONTransitionEditPart
						&& ((ONTransitionEditPart) editpart).canFire();
			}
		};
	}

}
