package roneditor.gef.actions.objectnet;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IWorkbenchPart;

import ronmodel.ObjectNet;

/**
 * @author Peggy
 */
public class ExportPNMLAction extends SelectionAction {

	public final static String ID = "roneditor.gef.actions.objectnet.ExportPNMLAction";
	private ObjectNet objectNet;

	public ExportPNMLAction(final IWorkbenchPart part) {
		super(part);
		setId(ID);
		setText("Export to PNML");
		setDescription("Export an object net as PNML");
		setToolTipText("Export an object net as PNML");

	}

	@Override
	public void run() {
		final FileDialog dialog = new FileDialog(getWorkbenchPart().getSite()
				.getShell(), SWT.SAVE);
		final String[] filterNames = new String[] { "Image Files",
				"All Files (*)" };
		final String[] filterExtensions = new String[] { "*.pnml" };
		final String filterPath = "/";
		dialog.setFilterNames(filterNames);
		dialog.setFilterExtensions(filterExtensions);
		dialog.setFilterPath(filterPath);
		dialog.setFileName("net_" + objectNet.getName());

		try {
			// ModelRepository.getInstance().createDocumentWorkspace("void");
			// final HashMap<ONNode, NodeHLAPI> nodemap = new HashMap<ONNode,
			// NodeHLAPI>();
			// int placeCounter = 0, transCounter = 0, arcCounter = 0;
			//
			// PetriNetDocHLAPI doc = new PetriNetDocHLAPI();
			// PetriNetHLAPI net = new PetriNetHLAPI("net0",
			// PNTypeHLAPI.COREMODEL, new NameHLAPI("PNML-Export"), doc);
			// PageHLAPI page = new PageHLAPI("toppage",
			// new NameHLAPI("PNML-Page"), null, net);
			//
			// for (ONNode onNode : objectNet.getNodes()) {
			// PositionHLAPI position = new PositionHLAPI(onNode.getX(),
			// onNode.getY());
			// NodeGraphicsHLAPI nodegraphics = new NodeGraphicsHLAPI(
			// position, new DimensionHLAPI(40, 40), null, null);
			//
			// AnnotationGraphicsHLAPI annotationGraphics = new
			// AnnotationGraphicsHLAPI(
			// new OffsetHLAPI(onNode.getX(), onNode.getY() + 40),
			// null, null, null);
			// NameHLAPI name = new NameHLAPI(annotationGraphics, onNode
			// .getName());
			//
			// NodeHLAPI pnmlNode;
			// if (onNode instanceof ONPlace) {
			// PTMarkingHLAPI marking = new PTMarkingHLAPI(
			// ((ONPlace) onNode).getTokens(), null);
			// pnmlNode = new PlaceHLAPI("place" + (placeCounter++) + "_"
			// + onNode.getName(), name, nodegraphics, marking,
			// page);
			// } else {
			// // onNode instanceof Transition!
			// transCounter++;
			// pnmlNode = new TransitionHLAPI("trans" + transCounter + "_"
			// + onNode.getName(), name, nodegraphics, page);
			//
			// }
			// nodemap.put(onNode, pnmlNode);
			// }
			// for (ONArc arc : objectNet.getArcs()) {
			// arcCounter++;
			// String arcname = arc.getName();
			// ONNode source1 = arc.getSource();
			// ONNode target1 = arc.getTarget();
			// new ArcHLAPI("arc" + arcCounter + "_" + arcname, nodemap
			// .get(source1), nodemap.get(target1), page);
			// }
			//
			// String export =
			// "<?xml version=\"1.0\" encoding=\"UTF-8\"?> <pnml>"
			// + net.toPNML() + "</pnml>";
			// export = export
			// .replace(
			//
			// "type=\"http://www.pnml.org/version-2009/grammar/pnmlcoremodel\"",
			//
			// "type=\"http://www.informatik.hu-berlin.de/top/pntd/ptNetb\" id=\"noID\"");
			// export = export.replace("<page>", "");
			// export = export.replace("</page>", "");
			// export = export.replace("<page id>", "");
			// export = export.replace("net id=\"net0\"", "net ");
			// export = export.replace("<page id=\"toppage\">", " ");
			// export = export.replace("<name><text>PNML-Page</text></name>",
			// " ");
			// export = export.replace("<name><text>PNML-Export</text></name>",
			// " ");
			//
			// /* PnmlExport pex = new PnmlExport(); */
			//
			// FileWriter pex = new FileWriter("D:/exporttest2.pnml");
			// pex.write(export);
			// pex.close();
			//
			// /* pex.export(doc,"D:/exporttest.pnml"); */
			// ModelRepository.getInstance().destroyCurrentWorkspace();

		} catch (final Exception e) {
			e.printStackTrace();
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	@Override
	protected boolean calculateEnabled() {
		final StructuredSelection selection = (StructuredSelection) getSelection();

		if (selection == null || selection.size() != 1) {
			return false;
		}

		final Object selectionElement = selection.getFirstElement();
		if (!(selectionElement instanceof EditPart)) {
			return false;
		}

		final Object model = ((EditPart) selectionElement).getModel();

		if (!(model instanceof ObjectNet)) {
			return false;
		}
		objectNet = (ObjectNet) model;
		return true;
	}

}