package roneditor.gef.actions.ron;

import org.eclipse.gef.ui.actions.EditorPartAction;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.plugin.AbstractUIPlugin;

/**
 * 
 * @author Tony Modica
 */
public class StopAutoSimulationAction extends EditorPartAction {

	private static final String DESC = "Stop simulation";

	public static final String ID = "StopSimulationAction";

	private static final String ICON_PATH = "$nl$/icons/";

	private static final String RUNNING_ICON = "org.eclipse.jdt.debug.ui.icons.full.etool16/term_sbook.gif";

	private static final ImageDescriptor image;

	static {
		image = AbstractUIPlugin.imageDescriptorFromPlugin("RONEditor",
				ICON_PATH + RUNNING_ICON);
	}

	public StopAutoSimulationAction(final IEditorPart editor) {
		super(editor, AS_PUSH_BUTTON);
		setDescription(DESC);
		setToolTipText(DESC);
		setId(ID);
		setImageDescriptor(image);
	}

	@Override
	public void run() {
		RunAutoSimulationAction.setRunning(false);
	}

	@Override
	protected boolean calculateEnabled() {
		return RunAutoSimulationAction.isRunning();
	}
}
