package roneditor.gef.actions.rule;

import org.eclipse.ui.IEditorPart;

import roneditor.ui.rule.RulePage;
import ronmodel.LHS;
import ronmodel.RHS;

/**
 * Copies the object net in the {@link LHS} to the {@link RHS} given a
 * {@link RulePage}.
 */
public class CopyLHSToRHSAction extends ObjectnetCopyAction {

	static public final String ID = "Copy LHS -> RHS";

	static private final String DESC = "Copy LHS -> RHS";

	static private final String TOOLTIP = "Copies the object net in the LHS to the RHS";

	public CopyLHSToRHSAction(final RulePage rulePage, final IEditorPart editor) {
		super(editor, rulePage);
		super.setId(ID);
		super.setText(DESC);
		super.setDescription(DESC);
		super.setToolTipText(TOOLTIP);
		target = getRulePage().getRule().getRhs();
		source = getRulePage().getRule().getLhs();
	}

}
