package roneditor.gef.actions.rule;

import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.ui.IEditorPart;

import roneditor.gef.commands.ron.CreateNACCommand;
import roneditor.ui.rule.RulePage;
import ronmodel.NAC;
import ronmodel.Rule;

/**
 * Create a new {@link NAC} given a {@link RulePage}.
 */
public class CreateNACAction extends WorkbenchPartAction {
	static public final String ID = "CreateNACAction";

	static public final String DESC = "Create empty NAC";

	static public final String TOOLTIP = "Create an empty NAC for the active Rule";

	private final RulePage rulePage;

	public CreateNACAction(final RulePage rulePage, final IEditorPart editor) {
		super(editor);
		this.rulePage = rulePage;
		setId(ID);
		setText(DESC);
		setDescription(DESC);
		setToolTipText(TOOLTIP);
	}

	@Override
	public void run() {
		final Rule rule = rulePage.getRule();
		final CreateNACCommand command = new CreateNACCommand(rule);
		execute(command);
		rulePage.setActiveNAC(command.getNac());
	}

	@Override
	protected boolean calculateEnabled() {
		return rulePage.getRule() != null;
	}
}
