package roneditor.gef.actions.rule;

import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.ui.IEditorPart;

import roneditor.gef.commands.ron.DeleteNACCommand;
import roneditor.ui.rule.RulePage;
import ronmodel.NAC;

/**
 * Action for deleting a {@link NAC} given a {@link RulePage}
 */
public class DeleteNACAction extends WorkbenchPartAction {
	static public final String ID = "DeleteNACAction";

	static private final String DESC = "Delete NAC";

	static private final String TOOLTIP = "Delete the active NAC from the active Rule";

	private final RulePage rulePage;

	public DeleteNACAction(final RulePage rulePage, final IEditorPart editor) {
		super(editor);
		this.rulePage = rulePage;
		setId(ID);
		setText(DESC);
		setDescription(DESC);
		setToolTipText(TOOLTIP);
	}

	@Override
	public void run() {
		final NAC nac = rulePage.getActiveNAC();
		rulePage.setNextNAC();
		execute(new DeleteNACCommand(nac));
	}

	@Override
	protected boolean calculateEnabled() {
		return rulePage.getActiveNAC() != null;
	}

}
