package roneditor.gef.editparts.ron.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import roneditor.gef.commands.ron.DeleteTokenCommand;
import ronmodel.Token;

/**
 * An EditPolicy for (Tree)EditParts of Tokens to handle deletion requests.
 * 
 * @author Tony Modica
 */
public class TokenComponentEditPolicy extends ComponentEditPolicy {

	/**
	 * @return A DeleteTokenCommand with the model of the host EditPart set.
	 * 
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#getDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	@Override
	protected Command getDeleteCommand(final GroupRequest request) {
		final DeleteTokenCommand command = new DeleteTokenCommand(
				(Token) getHost().getModel());
		return command;
	}
}
