package roneditor.gef.editpolicies;

import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

import roneditor.gef.editparts.objectnet.ONArcEditPart;

/**
 * {@link EditPolicy} for the end-points (e.g. arrow) of an
 * {@link ONArcEditPart}.
 */
public class ArcEndpointEditPolicy extends ConnectionEndpointEditPolicy {

	@Override
	protected void addSelectionHandles() {
		super.addSelectionHandles();
		((PolylineConnection) getConnection()).setLineWidth(2);
	}

	@Override
	protected void removeSelectionHandles() {
		super.removeSelectionHandles();
		((PolylineConnection) getConnection()).setLineWidth(1);
	}
}
