package roneditor.gef.figures.objectnet;

import muvitorkit.ui.utils.SWTResourceManager;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.MidpointLocator;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.SWT;

public class ArcFigure extends PolylineConnection {

	private final Label weightLabel;

	public ArcFigure(final String name, final int weight) {
		setForegroundColor(SWTResourceManager.getColor(128, 128, 128));
		final ConnectionEndpointLocator relationshipLocator = new ConnectionEndpointLocator(
				this, false);
		final MidpointLocator foo = new MidpointLocator(this, 0);
		relationshipLocator.setUDistance(5);
		relationshipLocator.setVDistance(10);
		weightLabel = new Label(String.valueOf(weight));
		weightLabel.setBackgroundColor(SWTResourceManager.getColor(255, 255,
				255));
		weightLabel.setForegroundColor(SWTResourceManager.getColor(0, 0, 0));
		weightLabel.setOpaque(true);
		add(weightLabel, foo);
		setTargetDecoration(new PolygonDecoration());
	}

	@Override
	public void paint(final Graphics graphics) {
		graphics.setAntialias(SWT.ON);
		super.paint(graphics);
	}

	public void setWeight(final int weight) {
		weightLabel.setText(String.valueOf(weight));
	}

	public void updateValueDisplay(final String name) {
		weightLabel.setText(name);
	}

	public Rectangle getValueLabelTextBounds() {
		return weightLabel.getTextBounds();
	}

}
