package roneditor.gef.figures.objectnet;

import org.eclipse.draw2d.ChopboxAnchor;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LayoutManager;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.graphics.Color;

abstract public class NodeFigure extends RectangleFigure {

	protected Label nameLabel;

	protected ChopboxAnchor incomingConnectionAnchor;

	protected ChopboxAnchor outgoingConnectionAnchor;

	protected boolean glow;

	protected boolean highlight;

	public NodeFigure() {
		final LayoutManager layout = new XYLayout();
		setLayoutManager(layout);
		nameLabel = new Label(" ");
		add(nameLabel);
		setBackgroundColor(ColorConstants.white);
		setForegroundColor(ColorConstants.black);
		setOpaque(false);
	}

	public void setGlow(final boolean glow) {
		this.glow = glow;
		repaint();
	}

	public void updateValueDisplay(final String name) {
		nameLabel.setText(name);
	}

	public Rectangle getValueLabelTextBounds() {
		return nameLabel.getTextBounds();
	}

	public ChopboxAnchor getSourceConnectionAnchor() {
		return outgoingConnectionAnchor;
	}

	public ChopboxAnchor getTargetConnectionAnchor() {
		return incomingConnectionAnchor;
	}

	public void setColor(final Color c) {
		setBackgroundColor(c);
	}

	public Color getColor() {
		return getBackgroundColor();
	}
}
