package roneditor.ui.objectnet;

import java.util.Map;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.tools.CreationTool;

import roneditor.gef.commands.objectnet.CreateNodeCommand;
import ronmodel.ONNode;

public class ObjectNetCreationTool extends CreationTool {

	@Override
	protected void executeCurrentCommand() {
		// Store current command
		final Command command = getCurrentCommand();

		super.executeCurrentCommand();

		if (command instanceof CreateNodeCommand) {
			final ONNode node = ((CreateNodeCommand) command).getONNode();
			final Map<?, ?> reg = getCurrentViewer().getEditPartRegistry();
			final EditPart editPart = (EditPart) reg.get(node);
			final Request request = new Request(
					RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
			command.setLabel(command.getLabel() + node.getName());
		}
	}
}