package roneditor.ui.objectnet;

/**
 * @author seb
 */

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.SharedCursors;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.swt.graphics.Cursor;

import roneditor.gef.commands.objectnet.ConnectONNodesCommand;
import roneditor.gef.commands.objectnet.CreateNodeCommand;
import roneditor.model.ModelCreationFactory;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;

public class ObjectNetMagicConnectionCreationTool extends
		ConnectionCreationTool {

	private static int placeno = 0;
	private static int transno = 0;

	@Override
	protected boolean handleCreateConnection() {

		// seb: creation request abgreifen und command auslesen
		final CreateConnectionRequest r = (CreateConnectionRequest) getSourceRequest();
		// seb: gewicht default auf 1 setzen
		final ONArc a = (ONArc) r.getNewObject();
		a.setWeight(1);
		if (r.getTargetEditPart() != null) {
			return super.handleCreateConnection();
		}
		final Command startcommand = r.getStartCommand();

		// seb: neuen EditPart erstellen
		final CreateRequest createrequest = new CreateRequest();

		createrequest.setLocation(getLocation());

		String name = "Node";
		if (startcommand instanceof ConnectONNodesCommand) {
			final ConnectONNodesCommand command = (ConnectONNodesCommand) startcommand;
			if (command.isSourcePlace()) {
				createrequest.setFactory(new ModelCreationFactory(
						ONTransition.class));
				final ONTransition o = (ONTransition) createrequest
						.getNewObject();
				command.setTarget(o);
				name = "Transition" + transno++;
			} else {
				createrequest
						.setFactory(new ModelCreationFactory(ONPlace.class));
				final ONPlace o = (ONPlace) createrequest.getNewObject();
				command.setTarget(o);
				name = "Place" + placeno++;
			}
		}
		// seb: Node erstellen
		final CreateNodeCommand c = (CreateNodeCommand) getCurrentViewer()
				.getRootEditPart().getContents().getCommand(createrequest);
		c.setName(name);
		getDomain().getCommandStack().execute(c);
		// seb: command ausfhren
		setCurrentCommand(startcommand);
		executeCurrentCommand();

		return super.handleCreateConnection();
	}

	private EditPartViewer viewer = null;

	@Override
	protected void setState(final int state) {
		if (state == STATE_CONNECTION_STARTED) {
			// store the current viewer for later testing in calculateCursor()
			viewer = getCurrentViewer();
		}
		super.setState(state);
	}

	@Override
	protected Cursor calculateCursor() {
		if (isInState(STATE_CONNECTION_STARTED) && viewer == getCurrentViewer()) {
			if (getTargetEditPart() == null) {
				// if we started a connection, are in the same viewer as before
				// and do point to the canvas then show enabled cursor for
				// inserting nodes
				return SharedCursors.CURSOR_TREE_ADD;
			}
		}
		return super.calculateCursor();
	}
}
