package roneditor.ui.objectnet;

import muvitorkit.animation.demo.AnimatingDemoAction3;
import muvitorkit.ui.ContextMenuProviderWithActionRegistry;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IMenuManager;

import roneditor.gef.actions.objectnet.FireONTransitionAction;
import aggSim.analyzer.LocalPlaceConflictAnalysisAction;

/**
 * This is used to populate the context menu for the Viewer in the
 * {@link ObjectNetPage}.
 * 
 * @author Tony Modica
 */
public class ObjectNetPageContextMenuProvider extends
		ContextMenuProviderWithActionRegistry {

	public ObjectNetPageContextMenuProvider(final EditPartViewer viewer) {
		super(viewer);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.gef.ContextMenuProvider#buildContextMenu(org.eclipse.jface
	 * .action.IMenuManager)
	 */
	@Override
	public void buildContextMenu(final IMenuManager menuManager) {
		String group = GEFActionConstants.GROUP_VIEW;
		dynamicAppendActionToGroup(menuManager, AnimatingDemoAction3.ID, group);

		group = GEFActionConstants.GROUP_REST;
		appendActionToGroup(menuManager, FireONTransitionAction.ID, group);
		appendActionToGroup(menuManager, LocalPlaceConflictAnalysisAction.ID,
				group);

		// dynamicAppendActionToGroup(menuManager, ExportPNMLAction.ID, group);

	}
}
