package roneditor.ui.ron;

import java.util.Map;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.tools.CreationTool;

import roneditor.gef.commands.ron.CreateHLNodeCommand;
import roneditor.gef.commands.ron.CreateHLTransitionCommand;
import ronmodel.HLNode;
import ronmodel.HLTransitionKind;

public class HLTransitionCreationTool extends CreationTool {

	public static final Object PROPERTY_HLTRANSITION_KIND = "kind";

	private HLTransitionKind kind;

	@Override
	protected void executeCurrentCommand() {
		// Store current command
		final CreateHLTransitionCommand command = (CreateHLTransitionCommand) getCurrentCommand();

		if (getKind() != null && command != null) {
			command.setKind(getKind());
		}
		super.executeCurrentCommand();

		// directEdit
		if (command != null) {
			final HLNode node = ((CreateHLNodeCommand) command).getHLNode();
			final Map<?, ?> reg = getCurrentViewer().getEditPartRegistry();
			final EditPart editPart = (EditPart) reg.get(node);
			final Request request = new Request(
					RequestConstants.REQ_DIRECT_EDIT);
			editPart.performRequest(request);
			command.setLabel(command.getLabel() + "'" + node.getName() + "'");
		}
	}

	/**
	 * @return the kind
	 */
	public HLTransitionKind getKind() {
		return kind;
	}

	/**
	 * @param kind
	 *            the kind to set
	 */
	public void setKind(final HLTransitionKind kind) {
		this.kind = kind;
	}
}