package roneditor.ui.ron;

import muvitorkit.animation.demo.AnimatingDemoAction1;
import muvitorkit.animation.demo.AnimatingDemoAction2;
import muvitorkit.animation.demo.AnimatingDemoAction3;
import muvitorkit.ui.ContextMenuProviderWithActionRegistry;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IMenuManager;

import roneditor.gef.actions.ron.ApplyRuleDialogAction;
import roneditor.gef.actions.ron.CreateHLPlaceAction;
import roneditor.gef.actions.ron.CreateTokenAction;
import roneditor.gef.actions.ron.FireDialogAction;
import roneditor.gef.actions.ron.FireHLTransitionAction;
import aggSim.analyzer.ConflictAnalysisAction;
import aggSim.analyzer.LocalPlaceConflictAnalysisAction;

/**
 * This is used to populate the context menu for the TreeViewer in the
 * RONEditor.
 * 
 * @author Tony Modica
 */
public class RONEditorContextMenuProvider extends
		ContextMenuProviderWithActionRegistry {

	public RONEditorContextMenuProvider(final EditPartViewer viewer) {
		super(viewer);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.gef.ContextMenuProvider#buildContextMenu(org.eclipse.jface
	 * .action.IMenuManager)
	 */
	@Override
	public void buildContextMenu(final IMenuManager menuManager) {
		// Actions in REST group
		String group = GEFActionConstants.GROUP_REST;
		dynamicAppendActionToGroup(menuManager, CreateHLPlaceAction.ID, group);
		dynamicAppendActionToGroup(menuManager, CreateTokenAction.ID, group);

		// Match and Fire Dialog
		appendActionToGroup(menuManager, FireHLTransitionAction.ID, group);
		dynamicAppendActionToGroup(menuManager, FireDialogAction.ID, group);
		dynamicAppendActionToGroup(menuManager, ApplyRuleDialogAction.ID, group);

		// Conflict Analysis
		appendActionToGroup(menuManager, ConflictAnalysisAction.ID, group);
		dynamicAppendActionToGroup(menuManager,
				LocalPlaceConflictAnalysisAction.ID, group);

		// Copy/Paste
		group = GEFActionConstants.GROUP_VIEW;
		dynamicAppendActionToGroup(menuManager, AnimatingDemoAction1.ID, group);
		dynamicAppendActionToGroup(menuManager, AnimatingDemoAction2.ID, group);
		dynamicAppendActionToGroup(menuManager, AnimatingDemoAction3.ID, group);
	}
}
