package roneditor.ui.rule;

import muvitorkit.ui.ContextMenuProviderWithActionRegistry;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IMenuManager;

import roneditor.gef.actions.rule.CopyLHSToNACAction;
import roneditor.gef.actions.rule.CopyLHSToRHSAction;
import roneditor.gef.actions.rule.CopyRHSToNACAction;
import roneditor.gef.actions.rule.CreateNACAction;
import roneditor.gef.actions.rule.DeleteNACAction;
import roneditor.gef.actions.rule.SwitchNACAction;

/**
 * This is used to populate the context menu for the Viewers in the
 * {@link RulePage}.
 * 
 * @author Tony Modica
 */
public class RulePageContextMenuProvider extends
		ContextMenuProviderWithActionRegistry {

	public RulePageContextMenuProvider(final EditPartViewer viewer) {
		super(viewer);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.gef.ContextMenuProvider#buildContextMenu(org.eclipse.jface
	 * .action.IMenuManager)
	 */
	@Override
	public void buildContextMenu(final IMenuManager menuManager) {

		// Sample Action to switch/create/delete NACs
		final String group = GEFActionConstants.GROUP_VIEW;
		dynamicAppendActionToGroup(menuManager, SwitchNACAction.ID, group);
		dynamicAppendActionToGroup(menuManager, CreateNACAction.ID, group);
		dynamicAppendActionToGroup(menuManager, DeleteNACAction.ID, group);

		// Copies
		dynamicAppendActionToGroup(menuManager, CopyLHSToRHSAction.ID, group);
		dynamicAppendActionToGroup(menuManager, CopyRHSToNACAction.ID, group);
		dynamicAppendActionToGroup(menuManager, CopyLHSToNACAction.ID, group);

		// dynamicAppendActionToGroup(menuManager, ExportPNMLAction.ID, group);

	}
}
