/**
 * <copyright>
 * </copyright>
 *
 * $Id: NodeColorImpl.java,v 1.10 2010/08/20 22:16:34 modica Exp $
 */
package ronmodel.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.swt.SWT;

import ronmodel.NodeColor;
import ronmodel.ONNode;
import ronmodel.RonmodelPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Node Color</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link ronmodel.impl.NodeColorImpl#getRed <em>Red</em>}</li>
 * <li>{@link ronmodel.impl.NodeColorImpl#getBlue <em>Blue</em>}</li>
 * <li>{@link ronmodel.impl.NodeColorImpl#getGreen <em>Green</em>}</li>
 * <li>{@link ronmodel.impl.NodeColorImpl#getNode <em>Node</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class NodeColorImpl extends EObjectImpl implements NodeColor {

	public NodeColorImpl(final int red, final int green, final int blue) {
		super();
		this.red = red;
		this.green = green;
		this.blue = blue;
	}

	public NodeColorImpl(float hue, final float saturation,
			final float brightness) {
		if (hue < 0 || hue > 360 || saturation < 0 || saturation > 1
				|| brightness < 0 || brightness > 1) {
			SWT.error(SWT.ERROR_INVALID_ARGUMENT);
		}
		float r, g, b;
		if (saturation == 0) {
			r = g = b = brightness;
		} else {
			if (hue == 360) {
				hue = 0;
			}
			hue /= 60;
			final int i = (int) hue;
			final float f = hue - i;
			final float p = brightness * (1 - saturation);
			final float q = brightness * (1 - saturation * f);
			final float t = brightness * (1 - saturation * (1 - f));
			switch (i) {
			case 0:
				r = brightness;
				g = t;
				b = p;
				break;
			case 1:
				r = q;
				g = brightness;
				b = p;
				break;
			case 2:
				r = p;
				g = brightness;
				b = t;
				break;
			case 3:
				r = p;
				g = q;
				b = brightness;
				break;
			case 4:
				r = t;
				g = p;
				b = brightness;
				break;
			case 5:
			default:
				r = brightness;
				g = p;
				b = q;
				break;
			}
		}
		red = (int) (r * 255 + 0.5);
		green = (int) (g * 255 + 0.5);
		blue = (int) (b * 255 + 0.5);
	}

	@Override
	public boolean equals(final Object object) {
		if (object == this) {
			return true;
		}
		if (object instanceof NodeColor) {
			final NodeColor nodeColor = (NodeColor) object;
			return nodeColor.getRed() == red && nodeColor.getGreen() == green
					&& nodeColor.getBlue() == blue;
		}
		return false;
	}

	@Override
	public int hashCode() {
		return blue << 16 | green << 8 | red;
	}

	/**
	 * The default value of the '{@link #getRed() <em>Red</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getRed()
	 * @generated
	 * @ordered
	 */
	protected static final int RED_EDEFAULT = 255;

	/**
	 * The cached value of the '{@link #getRed() <em>Red</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getRed()
	 * @generated
	 * @ordered
	 */
	protected int red = RED_EDEFAULT;

	/**
	 * The default value of the '{@link #getBlue() <em>Blue</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBlue()
	 * @generated
	 * @ordered
	 */
	protected static final int BLUE_EDEFAULT = 255;

	/**
	 * The cached value of the '{@link #getBlue() <em>Blue</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBlue()
	 * @generated
	 * @ordered
	 */
	protected int blue = BLUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getGreen() <em>Green</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getGreen()
	 * @generated
	 * @ordered
	 */
	protected static final int GREEN_EDEFAULT = 255;

	/**
	 * The cached value of the '{@link #getGreen() <em>Green</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getGreen()
	 * @generated
	 * @ordered
	 */
	protected int green = GREEN_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected NodeColorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RonmodelPackage.Literals.NODE_COLOR;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int getRed() {
		return red;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setRed(final int newRed) {
		final int oldRed = red;
		red = newRed;
		if (eNotificationRequired()) {
			eNotify(new ENotificationImpl(this, Notification.SET,
					RonmodelPackage.NODE_COLOR__RED, oldRed, red));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int getBlue() {
		return blue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setBlue(final int newBlue) {
		final int oldBlue = blue;
		blue = newBlue;
		if (eNotificationRequired()) {
			eNotify(new ENotificationImpl(this, Notification.SET,
					RonmodelPackage.NODE_COLOR__BLUE, oldBlue, blue));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public int getGreen() {
		return green;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setGreen(final int newGreen) {
		final int oldGreen = green;
		green = newGreen;
		if (eNotificationRequired()) {
			eNotify(new ENotificationImpl(this, Notification.SET,
					RonmodelPackage.NODE_COLOR__GREEN, oldGreen, green));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ONNode getNode() {
		if (eContainerFeatureID() != RonmodelPackage.NODE_COLOR__NODE) {
			return null;
		}
		return (ONNode) eContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetNode(final ONNode newNode,
			NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newNode,
				RonmodelPackage.NODE_COLOR__NODE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setNode(final ONNode newNode) {
		if (newNode != eInternalContainer()
				|| eContainerFeatureID() != RonmodelPackage.NODE_COLOR__NODE
				&& newNode != null) {
			if (EcoreUtil.isAncestor(this, newNode)) {
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString());
			}
			NotificationChain msgs = null;
			if (eInternalContainer() != null) {
				msgs = eBasicRemoveFromContainer(msgs);
			}
			if (newNode != null) {
				msgs = ((InternalEObject) newNode).eInverseAdd(this,
						RonmodelPackage.ON_NODE__COLOR, ONNode.class, msgs);
			}
			msgs = basicSetNode(newNode, msgs);
			if (msgs != null) {
				msgs.dispatch();
			}
		} else if (eNotificationRequired()) {
			eNotify(new ENotificationImpl(this, Notification.SET,
					RonmodelPackage.NODE_COLOR__NODE, newNode, newNode));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(final InternalEObject otherEnd,
			final int featureID, NotificationChain msgs) {
		switch (featureID) {
		case RonmodelPackage.NODE_COLOR__NODE:
			if (eInternalContainer() != null) {
				msgs = eBasicRemoveFromContainer(msgs);
			}
			return basicSetNode((ONNode) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(final InternalEObject otherEnd,
			final int featureID, final NotificationChain msgs) {
		switch (featureID) {
		case RonmodelPackage.NODE_COLOR__NODE:
			return basicSetNode(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(
			final NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case RonmodelPackage.NODE_COLOR__NODE:
			return eInternalContainer().eInverseRemove(this,
					RonmodelPackage.ON_NODE__COLOR, ONNode.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(final int featureID, final boolean resolve,
			final boolean coreType) {
		switch (featureID) {
		case RonmodelPackage.NODE_COLOR__RED:
			return getRed();
		case RonmodelPackage.NODE_COLOR__BLUE:
			return getBlue();
		case RonmodelPackage.NODE_COLOR__GREEN:
			return getGreen();
		case RonmodelPackage.NODE_COLOR__NODE:
			return getNode();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(final int featureID, final Object newValue) {
		switch (featureID) {
		case RonmodelPackage.NODE_COLOR__RED:
			setRed((Integer) newValue);
			return;
		case RonmodelPackage.NODE_COLOR__BLUE:
			setBlue((Integer) newValue);
			return;
		case RonmodelPackage.NODE_COLOR__GREEN:
			setGreen((Integer) newValue);
			return;
		case RonmodelPackage.NODE_COLOR__NODE:
			setNode((ONNode) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(final int featureID) {
		switch (featureID) {
		case RonmodelPackage.NODE_COLOR__RED:
			setRed(RED_EDEFAULT);
			return;
		case RonmodelPackage.NODE_COLOR__BLUE:
			setBlue(BLUE_EDEFAULT);
			return;
		case RonmodelPackage.NODE_COLOR__GREEN:
			setGreen(GREEN_EDEFAULT);
			return;
		case RonmodelPackage.NODE_COLOR__NODE:
			setNode((ONNode) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(final int featureID) {
		switch (featureID) {
		case RonmodelPackage.NODE_COLOR__RED:
			return red != RED_EDEFAULT;
		case RonmodelPackage.NODE_COLOR__BLUE:
			return blue != BLUE_EDEFAULT;
		case RonmodelPackage.NODE_COLOR__GREEN:
			return green != GREEN_EDEFAULT;
		case RonmodelPackage.NODE_COLOR__NODE:
			return getNode() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) {
			return super.toString();
		}

		final StringBuffer result = new StringBuffer(super.toString());
		result.append(" (red: ");
		result.append(red);
		result.append(", blue: ");
		result.append(blue);
		result.append(", green: ");
		result.append(green);
		result.append(')');
		return result.toString();
	}

} // NodeColorImpl
