/**
 * <copyright>
 * </copyright>
 *
 * $Id: RonmodelAdapterFactory.java,v 1.12 2009/07/21 19:13:52 modica Exp $
 */
package ronmodel.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;

import ronmodel.HLArc;
import ronmodel.HLNode;
import ronmodel.HLPlace;
import ronmodel.HLTransition;
import ronmodel.LHS;
import ronmodel.Mapping;
import ronmodel.NAC;
import ronmodel.Node;
import ronmodel.NodeColor;
import ronmodel.ONArc;
import ronmodel.ONNode;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;
import ronmodel.RHS;
import ronmodel.RON;
import ronmodel.RonmodelPackage;
import ronmodel.Rule;
import ronmodel.Token;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * 
 * @see ronmodel.RonmodelPackage
 * @generated
 */
public class RonmodelAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static RonmodelPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public RonmodelAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = RonmodelPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code> if
	 * the object is either the model's package or is an instance object of the
	 * model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(final Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected RonmodelSwitch<Adapter> modelSwitch = new RonmodelSwitch<Adapter>() {
		@Override
		public Adapter caseRON(final RON object) {
			return createRONAdapter();
		}

		@Override
		public Adapter caseNode(final Node object) {
			return createNodeAdapter();
		}

		@Override
		public Adapter caseHLNode(final HLNode object) {
			return createHLNodeAdapter();
		}

		@Override
		public Adapter caseHLPlace(final HLPlace object) {
			return createHLPlaceAdapter();
		}

		@Override
		public Adapter caseHLTransition(final HLTransition object) {
			return createHLTransitionAdapter();
		}

		@Override
		public Adapter caseHLArc(final HLArc object) {
			return createHLArcAdapter();
		}

		@Override
		public Adapter caseToken(final Token object) {
			return createTokenAdapter();
		}

		@Override
		public Adapter caseObjectNet(final ObjectNet object) {
			return createObjectNetAdapter();
		}

		@Override
		public Adapter caseONNode(final ONNode object) {
			return createONNodeAdapter();
		}

		@Override
		public Adapter caseONPlace(final ONPlace object) {
			return createONPlaceAdapter();
		}

		@Override
		public Adapter caseONTransition(final ONTransition object) {
			return createONTransitionAdapter();
		}

		@Override
		public Adapter caseONArc(final ONArc object) {
			return createONArcAdapter();
		}

		@Override
		public Adapter caseRule(final Rule object) {
			return createRuleAdapter();
		}

		@Override
		public Adapter caseMapping(final Mapping object) {
			return createMappingAdapter();
		}

		@Override
		public Adapter caseLHS(final LHS object) {
			return createLHSAdapter();
		}

		@Override
		public Adapter caseRHS(final RHS object) {
			return createRHSAdapter();
		}

		@Override
		public Adapter caseNAC(final NAC object) {
			return createNACAdapter();
		}

		@Override
		public Adapter caseNodeColor(final NodeColor object) {
			return createNodeColorAdapter();
		}

		@Override
		public Adapter caseEModelElement(final EModelElement object) {
			return createEModelElementAdapter();
		}

		@Override
		public Adapter caseENamedElement(final ENamedElement object) {
			return createENamedElementAdapter();
		}

		@Override
		public Adapter defaultCase(final EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param target
	 *            the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(final Notifier target) {
		return modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.RON
	 * <em>RON</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.RON
	 * @generated
	 */
	public Adapter createRONAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Node
	 * <em>Node</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.Node
	 * @generated
	 */
	public Adapter createNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.HLNode
	 * <em>HL Node</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.HLNode
	 * @generated
	 */
	public Adapter createHLNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.HLPlace
	 * <em>HL Place</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.HLPlace
	 * @generated
	 */
	public Adapter createHLPlaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link ronmodel.HLTransition <em>HL Transition</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.HLTransition
	 * @generated
	 */
	public Adapter createHLTransitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.HLArc
	 * <em>HL Arc</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.HLArc
	 * @generated
	 */
	public Adapter createHLArcAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Token
	 * <em>Token</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.Token
	 * @generated
	 */
	public Adapter createTokenAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ObjectNet
	 * <em>Object Net</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.ObjectNet
	 * @generated
	 */
	public Adapter createObjectNetAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ONNode
	 * <em>ON Node</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.ONNode
	 * @generated
	 */
	public Adapter createONNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ONPlace
	 * <em>ON Place</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.ONPlace
	 * @generated
	 */
	public Adapter createONPlaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link ronmodel.ONTransition <em>ON Transition</em>}'. <!--
	 * begin-user-doc --> This default implementation returns null so that we
	 * can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.ONTransition
	 * @generated
	 */
	public Adapter createONTransitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.ONArc
	 * <em>ON Arc</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.ONArc
	 * @generated
	 */
	public Adapter createONArcAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Rule
	 * <em>Rule</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.Rule
	 * @generated
	 */
	public Adapter createRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.Mapping
	 * <em>Mapping</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.Mapping
	 * @generated
	 */
	public Adapter createMappingAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.LHS
	 * <em>LHS</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.LHS
	 * @generated
	 */
	public Adapter createLHSAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.RHS
	 * <em>RHS</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.RHS
	 * @generated
	 */
	public Adapter createRHSAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.NAC
	 * <em>NAC</em>}'. <!-- begin-user-doc --> This default implementation
	 * returns null so that we can easily ignore cases; it's useful to ignore a
	 * case when inheritance will catch all the cases anyway. <!-- end-user-doc
	 * -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.NAC
	 * @generated
	 */
	public Adapter createNACAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ronmodel.NodeColor
	 * <em>Node Color</em>}'. <!-- begin-user-doc --> This default
	 * implementation returns null so that we can easily ignore cases; it's
	 * useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see ronmodel.NodeColor
	 * @generated
	 */
	public Adapter createNodeColorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link org.eclipse.emf.ecore.EModelElement <em>EModel Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see org.eclipse.emf.ecore.EModelElement
	 * @generated
	 */
	public Adapter createEModelElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '
	 * {@link org.eclipse.emf.ecore.ENamedElement <em>ENamed Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see org.eclipse.emf.ecore.ENamedElement
	 * @generated
	 */
	public Adapter createENamedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} // RonmodelAdapterFactory
