/**
 * <copyright>
 * </copyright>
 *
 * $Id: RonmodelSwitch.java,v 1.14 2009/07/21 19:13:52 modica Exp $
 */
package ronmodel.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;

import ronmodel.HLArc;
import ronmodel.HLNode;
import ronmodel.HLPlace;
import ronmodel.HLTransition;
import ronmodel.LHS;
import ronmodel.Mapping;
import ronmodel.NAC;
import ronmodel.Node;
import ronmodel.NodeColor;
import ronmodel.ONArc;
import ronmodel.ONNode;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;
import ronmodel.RHS;
import ronmodel.RON;
import ronmodel.RonmodelPackage;
import ronmodel.Rule;
import ronmodel.Token;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * 
 * @see ronmodel.RonmodelPackage
 * @generated
 */
public class RonmodelSwitch<T> {
	/**
	 * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static RonmodelPackage modelPackage;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public RonmodelSwitch() {
		if (modelPackage == null) {
			modelPackage = RonmodelPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	public T doSwitch(final EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected T doSwitch(final EClass theEClass, final EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		final List<EClass> eSuperTypes = theEClass.getESuperTypes();
		return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch(
				eSuperTypes.get(0), theEObject);

	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected T doSwitch(final int classifierID, final EObject theEObject) {
		switch (classifierID) {
		case RonmodelPackage.RON: {
			final RON ron = (RON) theEObject;
			T result = caseRON(ron);
			if (result == null) {
				result = caseENamedElement(ron);
			}
			if (result == null) {
				result = caseEModelElement(ron);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.NODE: {
			final Node node = (Node) theEObject;
			T result = caseNode(node);
			if (result == null) {
				result = caseENamedElement(node);
			}
			if (result == null) {
				result = caseEModelElement(node);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.HL_NODE: {
			final HLNode hlNode = (HLNode) theEObject;
			T result = caseHLNode(hlNode);
			if (result == null) {
				result = caseNode(hlNode);
			}
			if (result == null) {
				result = caseENamedElement(hlNode);
			}
			if (result == null) {
				result = caseEModelElement(hlNode);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.HL_PLACE: {
			final HLPlace hlPlace = (HLPlace) theEObject;
			T result = caseHLPlace(hlPlace);
			if (result == null) {
				result = caseHLNode(hlPlace);
			}
			if (result == null) {
				result = caseNode(hlPlace);
			}
			if (result == null) {
				result = caseENamedElement(hlPlace);
			}
			if (result == null) {
				result = caseEModelElement(hlPlace);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.HL_TRANSITION: {
			final HLTransition hlTransition = (HLTransition) theEObject;
			T result = caseHLTransition(hlTransition);
			if (result == null) {
				result = caseHLNode(hlTransition);
			}
			if (result == null) {
				result = caseNode(hlTransition);
			}
			if (result == null) {
				result = caseENamedElement(hlTransition);
			}
			if (result == null) {
				result = caseEModelElement(hlTransition);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.HL_ARC: {
			final HLArc hlArc = (HLArc) theEObject;
			T result = caseHLArc(hlArc);
			if (result == null) {
				result = caseENamedElement(hlArc);
			}
			if (result == null) {
				result = caseEModelElement(hlArc);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.TOKEN: {
			final Token token = (Token) theEObject;
			T result = caseToken(token);
			if (result == null) {
				result = caseENamedElement(token);
			}
			if (result == null) {
				result = caseEModelElement(token);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.OBJECT_NET: {
			final ObjectNet objectNet = (ObjectNet) theEObject;
			T result = caseObjectNet(objectNet);
			if (result == null) {
				result = caseToken(objectNet);
			}
			if (result == null) {
				result = caseENamedElement(objectNet);
			}
			if (result == null) {
				result = caseEModelElement(objectNet);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.ON_NODE: {
			final ONNode onNode = (ONNode) theEObject;
			T result = caseONNode(onNode);
			if (result == null) {
				result = caseNode(onNode);
			}
			if (result == null) {
				result = caseENamedElement(onNode);
			}
			if (result == null) {
				result = caseEModelElement(onNode);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.ON_PLACE: {
			final ONPlace onPlace = (ONPlace) theEObject;
			T result = caseONPlace(onPlace);
			if (result == null) {
				result = caseONNode(onPlace);
			}
			if (result == null) {
				result = caseNode(onPlace);
			}
			if (result == null) {
				result = caseENamedElement(onPlace);
			}
			if (result == null) {
				result = caseEModelElement(onPlace);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.ON_TRANSITION: {
			final ONTransition onTransition = (ONTransition) theEObject;
			T result = caseONTransition(onTransition);
			if (result == null) {
				result = caseONNode(onTransition);
			}
			if (result == null) {
				result = caseNode(onTransition);
			}
			if (result == null) {
				result = caseENamedElement(onTransition);
			}
			if (result == null) {
				result = caseEModelElement(onTransition);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.ON_ARC: {
			final ONArc onArc = (ONArc) theEObject;
			T result = caseONArc(onArc);
			if (result == null) {
				result = caseENamedElement(onArc);
			}
			if (result == null) {
				result = caseEModelElement(onArc);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.RULE: {
			final Rule rule = (Rule) theEObject;
			T result = caseRule(rule);
			if (result == null) {
				result = caseToken(rule);
			}
			if (result == null) {
				result = caseENamedElement(rule);
			}
			if (result == null) {
				result = caseEModelElement(rule);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.MAPPING: {
			final Mapping mapping = (Mapping) theEObject;
			T result = caseMapping(mapping);
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.LHS: {
			final LHS lhs = (LHS) theEObject;
			T result = caseLHS(lhs);
			if (result == null) {
				result = caseObjectNet(lhs);
			}
			if (result == null) {
				result = caseToken(lhs);
			}
			if (result == null) {
				result = caseENamedElement(lhs);
			}
			if (result == null) {
				result = caseEModelElement(lhs);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.RHS: {
			final RHS rhs = (RHS) theEObject;
			T result = caseRHS(rhs);
			if (result == null) {
				result = caseObjectNet(rhs);
			}
			if (result == null) {
				result = caseToken(rhs);
			}
			if (result == null) {
				result = caseENamedElement(rhs);
			}
			if (result == null) {
				result = caseEModelElement(rhs);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.NAC: {
			final NAC nac = (NAC) theEObject;
			T result = caseNAC(nac);
			if (result == null) {
				result = caseObjectNet(nac);
			}
			if (result == null) {
				result = caseToken(nac);
			}
			if (result == null) {
				result = caseENamedElement(nac);
			}
			if (result == null) {
				result = caseEModelElement(nac);
			}
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		case RonmodelPackage.NODE_COLOR: {
			final NodeColor nodeColor = (NodeColor) theEObject;
			T result = caseNodeColor(nodeColor);
			if (result == null) {
				result = defaultCase(theEObject);
			}
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>RON</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>RON</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRON(final RON object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Node</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNode(final Node object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>HL Node</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>HL Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHLNode(final HLNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>HL Place</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>HL Place</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHLPlace(final HLPlace object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>HL Transition</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>HL Transition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHLTransition(final HLTransition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>HL Arc</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>HL Arc</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHLArc(final HLArc object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Token</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Token</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToken(final Token object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Object Net</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Object Net</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseObjectNet(final ObjectNet object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ON Node</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ON Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseONNode(final ONNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ON Place</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ON Place</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseONPlace(final ONPlace object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ON Transition</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ON Transition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseONTransition(final ONTransition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ON Arc</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ON Arc</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseONArc(final ONArc object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Rule</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRule(final Rule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Mapping</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Mapping</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMapping(final Mapping object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>LHS</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>LHS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLHS(final LHS object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>RHS</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>RHS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRHS(final RHS object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>NAC</em>'. <!-- begin-user-doc --> This implementation returns null;
	 * returning a non-null result will terminate the switch. <!-- end-user-doc
	 * -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>NAC</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNAC(final NAC object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Node Color</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Node Color</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNodeColor(final NodeColor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>EModel Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>EModel Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEModelElement(final EModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ENamed Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ENamed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseENamedElement(final ENamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(final EObject object) {
		return null;
	}

} // RonmodelSwitch
